



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>雷林鹏分享：C# 运算符重载</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">雷林鹏分享：C# 运算符重载</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-21 14:20:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　C# 运算符重载</p>
<p>　　您可以重定义或重载 C# 中内置的运算符。因此，程序员也可以使用用户自定义类型的运算符。重载运算符是具有特殊名称的函数，是通过关键字 operator 后跟运算符的符号来定义的。与其他函数一样，重载运算符有返回类型和参数列表。</p>
<p>　　例如，请看下面的函数：</p>
<p>　　public static Box operator+ (Box b, Box c)</p>
<p>　　{</p>
<p>　　Box box = new Box();</p>
<p>　　box.length = b.length + c.length;</p>
<p>　　box.breadth = b.breadth + c.breadth;</p>
<p>　　box.height = b.height + c.height;</p>
<p>　　return box;</p>
<p>　　}</p>
<p>　　上面的函数为用户自定义的类 Box 实现了加法运算符(+)。它把两个 Box 对象的属性相加，并返回相加后的 Box 对象。</p>
<p>　　运算符重载的实现</p>
<p>　　下面的程序演示了完整的实现：</p>
<p>　　using System;</p>
<p>　　namespace OperatorOvlApplication</p>
<p>　　{</p>
<p>　　class Box</p>
<p>　　{</p>
<p>　　private double length; // 长度</p>
<p>　　private double breadth; // 宽度</p>
<p>　　private double height; // 高度</p>
<p>　　public double getVolume()</p>
<p>　　{</p>
<p>　　return length * breadth * height;</p>
<p>　　}</p>
<p>　　public void setLength( double len )</p>
<p>　　{</p>
<p>　　length = len;</p>
<p>　　}</p>
<p>　　public void setBreadth( double bre )</p>
<p>　　{</p>
<p>　　breadth = bre;</p>
<p>　　}</p>
<p>　　public void setHeight( double hei )</p>
<p>　　{</p>
<p>　　height = hei;</p>
<p>　　}</p>
<p>　　// 重载 + 运算符来把两个 Box 对象相加</p>
<p>　　public static Box operator+ (Box b, Box c)</p>
<p>　　{</p>
<p>　　Box box = new Box();</p>
<p>　　box.length = b.length + c.length;</p>
<p>　　box.breadth = b.breadth + c.breadth;</p>
<p>　　box.height = b.height + c.height;</p>
<p>　　return box;</p>
<p>　　}</p>
<p>　　}</p>
<p>　　class Tester</p>
<p>　　{</p>
<p>　　static void Main(string[] args)</p>
<p>　　{</p>
<p>　　Box Box1 = new Box(); // 声明 Box1，类型为 Box</p>
<p>　　Box Box2 = new Box(); // 声明 Box2，类型为 Box</p>
<p>　　Box Box3 = new Box(); // 声明 Box3，类型为 Box</p>
<p>　　double volume = 0.0; // 体积</p>
<p>　　// Box1 详述</p>
<p>　　Box1.setLength(6.0);</p>
<p>　　Box1.setBreadth(7.0);</p>
<p>　　Box1.setHeight(5.0);</p>
<p>　　// Box2 详述</p>
<p>　　Box2.setLength(12.0);</p>
<p>　　Box2.setBreadth(13.0);</p>
<p>　　Box2.setHeight(10.0);</p>
<p>　　// Box1 的体积</p>
<p>　　volume = Box1.getVolume();</p>
<p>　　Console.WriteLine("Box1 的体积： {0}", volume);</p>
<p>　　// Box2 的体积</p>
<p>　　volume = Box2.getVolume();</p>
<p>　　Console.WriteLine("Box2 的体积： {0}", volume);</p>
<p>　　// 把两个对象相加</p>
<p>　　Box3 = Box1 + Box2;</p>
<p>　　// Box3 的体积</p>
<p>　　volume = Box3.getVolume();</p>
<p>　　Console.WriteLine("Box3 的体积： {0}", volume);</p>
<p>　　Console.ReadKey();</p>
<p>　　}</p>
<p>　　}</p>
<p>　　}</p>
<p>　　当上面的代码被编译和执行时，它会产生下列结果：</p>
<p>　　Box1 的体积： 210</p>
<p>　　Box2 的体积： 1560</p>
<p>　　Box3 的体积： 5400</p>
<p>　　可重载和不可重载运算符</p>
<p>　　下表描述了 C# 中运算符重载的能力：</p>
<p>　　运算符描述</p>
<p>　　+, -, !, ~, ++, --这些一元运算符只有一个操作数，且可以被重载。</p>
<p>　　+, -, *, /, %这些二元运算符带有两个操作数，且可以被重载。</p>
<p>　　==, !=, &lt;, &gt;, &lt;=, &gt;=这些比较运算符可以被重载。</p>
<p>　　&amp;&amp;, ||这些条件逻辑运算符不能被直接重载。</p>
<p>　　+=, -=, *=, /=, %=这些赋值运算符不能被重载。</p>
<p>　　=, ., ?:, -&gt;, new, is, sizeof, typeof这些运算符不能被重载。</p>
<p>　　实例</p>
<p>　　针对上述讨论，让我们扩展上面的实例，重载更多的运算符：</p>
<p>　　using System;</p>
<p>　　namespace OperatorOvlApplication</p>
<p>　　{</p>
<p>　　class Box</p>
<p>　　{</p>
<p>　　private double length; // 长度</p>
<p>　　private double breadth; // 宽度</p>
<p>　　private double height; // 高度</p>
<p>　　public double getVolume()</p>
<p>　　{</p>
<p>　　return length * breadth * height;</p>
<p>　　}</p>
<p>　　public void setLength( double len )</p>
<p>　　{</p>
<p>　　length = len;</p>
<p>　　}</p>
<p>　　public void setBreadth( double bre )</p>
<p>　　{</p>
<p>　　breadth = bre;</p>
<p>　　}</p>
<p>　　public void setHeight( double hei )</p>
<p>　　{</p>
<p>　　height = hei;</p>
<p>　　}</p>
<p>　　// 重载 + 运算符来把两个 Box 对象相加</p>
<p>　　public static Box operator+ (Box b, Box c)</p>
<p>　　{</p>
<p>　　Box box = new Box();</p>
<p>　　box.length = b.length + c.length;</p>
<p>　　box.breadth = b.breadth + c.breadth;</p>
<p>　　box.height = b.height + c.height;</p>
<p>　　return box;</p>
<p>　　}</p>
<p>　　public static bool operator == (Box lhs, Box rhs)</p>
<p>　　{</p>
<p>　　bool status = false;</p>
<p>　　if (lhs.length == rhs.length &amp;&amp; lhs.height == rhs.height</p>
<p>　　&amp;&amp; lhs.breadth == rhs.breadth)</p>
<p>　　{</p>
<p>　　status = true;</p>
<p>　　}</p>
<p>　　return status;</p>
<p>　　}</p>
<p>　　public static bool operator !=(Box lhs, Box rhs)</p>
<p>　　{</p>
<p>　　bool status = false;</p>
<p>　　if (lhs.length != rhs.length || lhs.height != rhs.height</p>
<p>　　|| lhs.breadth != rhs.breadth)</p>
<p>　　{</p>
<p>　　status = true;</p>
<p>　　}</p>
<p>　　return status;</p>
<p>　　}</p>
<p>　　public static bool operator &lt;(Box lhs, Box rhs)</p>
<p>　　{</p>
<p>　　bool status = false;</p>
<p>　　if (lhs.length &lt; rhs.length &amp;&amp; lhs.height</p>
<p>　　&lt; rhs.height &amp;&amp; lhs.breadth &lt; rhs.breadth)</p>
<p>　　{</p>
<p>　　status = true;</p>
<p>　　}</p>
<p>　　return status;</p>
<p>　　}</p>
<p>　　public static bool operator &gt;(Box lhs, Box rhs)</p>
<p>　　{</p>
<p>　　bool status = false;</p>
<p>　　if (lhs.length &gt; rhs.length &amp;&amp; lhs.height</p>
<p>　　&gt; rhs.height &amp;&amp; lhs.breadth &gt; rhs.breadth)</p>
<p>　　{</p>
<p>　　status = true;</p>
<p>　　}</p>
<p>　　return status;</p>
<p>　　}</p>
<p>　　public static bool operator &lt;=(Box lhs, Box rhs)</p>
<p>　　{</p>
<p>　　bool status = false;</p>
<p>　　if (lhs.length &lt;= rhs.length &amp;&amp; lhs.height</p>
<p>　　&lt;= rhs.height &amp;&amp; lhs.breadth &lt;= rhs.breadth)</p>
<p>　　{</p>
<p>　　status = true;</p>
<p>　　}</p>
<p>　　return status;</p>
<p>　　}</p>
<p>　　public static bool operator &gt;=(Box lhs, Box rhs)</p>
<p>　　{</p>
<p>　　bool status = false;</p>
<p>　　if (lhs.length &gt;= rhs.length &amp;&amp; lhs.height</p>
<p>　　&gt;= rhs.height &amp;&amp; lhs.breadth &gt;= rhs.breadth)</p>
<p>　　{</p>
<p>　　status = true;</p>
<p>　　}</p>
<p>　　return status;</p>
<p>　　}</p>
<p>　　public override string ToString()</p>
<p>　　{</p>
<p>　　return String.Format("({0}, {1}, {2})", length, breadth, height);</p>
<p>　　}</p>
<p>　　}</p>
<p>　　class Tester</p>
<p>　　{</p>
<p>　　static void Main(string[] args)</p>
<p>　　{</p>
<p>　　Box Box1 = new Box(); // 声明 Box1，类型为 Box</p>
<p>　　Box Box2 = new Box(); // 声明 Box2，类型为 Box</p>
<p>　　Box Box3 = new Box(); // 声明 Box3，类型为 Box</p>
<p>　　Box Box4 = new Box();</p>
<p>　　double volume = 0.0; // 体积</p>
<p>　　// Box1 详述</p>
<p>　　Box1.setLength(6.0);</p>
<p>　　Box1.setBreadth(7.0);</p>
<p>　　Box1.setHeight(5.0);</p>
<p>　　// Box2 详述</p>
<p>　　Box2.setLength(12.0);</p>
<p>　　Box2.setBreadth(13.0);</p>
<p>　　Box2.setHeight(10.0);</p>
<p>　　// 使用重载的 ToString() 显示两个盒子</p>
<p>　　Console.WriteLine("Box1： {0}", Box1.ToString());</p>
<p>　　Console.WriteLine("Box2： {0}", Box2.ToString());</p>
<p>　　// Box1 的体积</p>
<p>　　volume = Box1.getVolume();</p>
<p>　　Console.WriteLine("Box1 的体积： {0}", volume);</p>
<p>　　// Box2 的体积</p>
<p>　　volume = Box2.getVolume();</p>
<p>　　Console.WriteLine("Box2 的体积： {0}", volume);</p>
<p>　　// 把两个对象相加</p>
<p>　　Box3 = Box1 + Box2;</p>
<p>　　Console.WriteLine("Box3： {0}", Box3.ToString());</p>
<p>　　// Box3 的体积</p>
<p>　　volume = Box3.getVolume();</p>
<p>　　Console.WriteLine("Box3 的体积： {0}", volume);</p>
<p>　　//comparing the boxes</p>
<p>　　if (Box1 &gt; Box2)</p>
<p>　　Console.WriteLine("Box1 大于 Box2");</p>
<p>　　else</p>
<p>　　Console.WriteLine("Box1 不大于 Box2");</p>
<p>　　if (Box1 &lt; Box2)</p>
<p>　　Console.WriteLine("Box1 小于 Box2");</p>
<p>　　else</p>
<p>　　Console.WriteLine("Box1 不小于 Box2");</p>
<p>　　if (Box1 &gt;= Box2)</p>
<p>　　Console.WriteLine("Box1 大于等于 Box2");</p>
<p>　　else</p>
<p>　　Console.WriteLine("Box1 不大于等于 Box2");</p>
<p>　　if (Box1 &lt;= Box2)</p>
<p>　　Console.WriteLine("Box1 小于等于 Box2");</p>
<p>　　else</p>
<p>　　Console.WriteLine("Box1 不小于等于 Box2");</p>
<p>　　if (Box1 != Box2)</p>
<p>　　Console.WriteLine("Box1 不等于 Box2");</p>
<p>　　else</p>
<p>　　Console.WriteLine("Box1 等于 Box2");</p>
<p>　　Box4 = Box3;</p>
<p>　　if (Box3 == Box4)</p>
<p>　　Console.WriteLine("Box3 等于 Box4");</p>
<p>　　else</p>
<p>　　Console.WriteLine("Box3 不等于 Box4");</p>
<p>　　Console.ReadKey();</p>
<p>　　}</p>
<p>　　}</p>
<p>　　}</p>
<p>　　当上面的代码被编译和执行时，它会产生下列结果：</p>
<p>　　Box1： (6, 7, 5)</p>
<p>　　Box2： (12, 13, 10)</p>
<p>　　Box1 的体积： 210</p>
<p>　　Box2 的体积： 1560</p>
<p>　　Box3： (18, 20, 15)</p>
<p>　　Box3 的体积： 5400</p>
<p>　　Box1 不大于 Box2</p>
<p>　　Box1 小于 Box2</p>
<p>　　Box1 不大于等于 Box2</p>
<p>　　Box1 小于等于 Box2</p>
<p>　　Box1 不等于 Box2</p>
<p>　　Box3 等于 Box4</p>
<p>　　本文转载自：w3cschool(编辑：雷林鹏 来源：网络)</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kjodr9.html">JS原型继承和类式继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kk65j8.html">Android横竖屏切换</a>
		</li>
						<li><a href="https://www.batexi.com/a/49513keq.html">thinkphp自定义权限管理之名称判断</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rxm1d9.html">301 redirect Domain Name using global&period;asax</a>
		</li>
						<li><a href="https://www.batexi.com/a/4955k6v9.html">opencv  hog&plus;svm行人检测</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok1j619.html">读取Config文件工具类 PropertiesConfig&period;java</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdnz0e8.html">网站导航不止有hao123！</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjmkz79.html">HDU4718 The LCIS on the Tree&lpar;LCT&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ono1j9.html">14&period;6&period;8 Configuring the InnoDB Master Thread IO Rate 配置InnoDB 主线程IO 速率&colon;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdx1048.html">error userinfo error pos  5  友盟分享    网页分享&lpar;无新浪微博客户端&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m7nlj8.html">纯JAVA驱动：sqlserver版本不同，驱动与连接也有所区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg7j4d8.html">noi2015 day1 T2软件包管理器</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yznyz8.html">idea右键无法生成javaclass</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj3yy49.html">Django&plus;Xadmin打造在线教育系统&lpar;五&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj5jrr9.html">linux mysql 定时备份 使用crontab</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd6dkv9.html">js里获取页面高度和文档高度</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1okrlq.html">mysql试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2vov0q.html">hdu 4707 仓鼠 记录深度 &lpar;BFS&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pmjpeq.html">&period;NET 互联网技术简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve0wkx9.html">pipelinedb 滑动窗口</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyv421dq.html">ARM的Trust Zone技术</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kmx5wq.html">GCC编译器ABI</a>
			</li>
						<li><a href="https://www.batexi.com/a/9637mmn9.html">tensorflow显存管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4vdleq.html">VS2010&sol;MFC编程入门之四十五（MFC常用类：CFile文件操作类）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl55rr9.html">REST服务安全-双向认证</a>
			</li>
						<li><a href="https://www.batexi.com/a/953mjrm8.html">Python 让PIP源使用国内镜像，提升下载速度和安装成功率</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmn25l9.html">Django框架----ORM数据库操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjlkmr8.html">安装SQL2008时显示：RebootRequiredCheck 检查是否需要挂起计算机重新启动。</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pmdm0q.html">Unity 使用C&sol;C&plus;&plus; 跨平台终极解决方案（PC，iOS，Android，以及支持C&sol;C&plus;&plus;的平台）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vpoz5q.html">CodeForces 1105E</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
